<?php
/*
Plugin Name: Метабокс Автора
Plugin URI: http://tkacheff.ru/697/plugins-author-metabox/
Description: Настраиваемый Метабокс Автора публикации. Содержит 3 бокса: Бокс - информация об Авторе с иконками социальных сетей, Бокс - последние посты Атора, и Бокс - контактная форма для связи с Автором.
Version: 1.0.1
Author: Михаил Ткачев
Author URI: http://tkacheff.ru
*/
/* Copyright 2014 */

$asdb_dir = preg_replace("/^.*[\/\\\]/", "", dirname(__FILE__));
define("ASDB_DIR", "/wp-content/plugins/" . $asdb_dir);


class ASDBAuthorInfo {
// формируем токен для проверки отправки email из формы
function token() {
	$admin_email = get_option("admin_email");
	return md5("asdb-" . $admin_email . date("WY"));
	}

}
$asdb = new ASDBAuthorInfo();

//Загрузка скриптов и стилей
function asdb_scripts() {
    wp_enqueue_script('jquery');
    wp_enqueue_script('asdb_functions', plugins_url('/inc/functions.js', __FILE__), 'jquery');
    wp_enqueue_style('asdb_style', plugins_url('/inc/asdb.css', __FILE__));
}
add_action('wp_enqueue_scripts', 'asdb_scripts');

//Выводим в профиле пользователя настройки плагина (чекбокс отмечен - Да, Снят - Нет)
add_action('show_user_profile', 'asdb_preferences');
add_action('edit_user_profile', 'asdb_preferences');

function asdb_preferences($user) {
    $asdb_email_status = (esc_attr(get_the_author_meta('asdb_email_status', $user->ID)) != 'allow') ? '' : 'checked';
    $asdb_metabox_status = (esc_attr(get_the_author_meta('asdb_metabox_status', $user->ID)) != 'allow') ? '' : 'checked';
    $asdb_related_status = (esc_attr(get_the_author_meta('asdb_related_status', $user->ID)) != 'allow') ? '' : 'checked';
echo <<<END
    <h3>Настройка плагина Метабокс Автора</h3>
  <table class="form-table">
<tr>
	<th><label>Выводить метабокс Автора?</label></th>
	<td><input type="checkbox" name="asdb_metabox_status" id="asdb_metabox_status" value="allow" $asdb_metabox_status /><br /></td>
</tr><tr>
	<th><label>Принимать почту с сайта?</label></th>
	<td><input type="checkbox" name="asdb_email_status" id="asdb_email_status" value="allow" $asdb_email_status /><br /></td>
</tr><tr>
	<th><label>Выводить последние сообщения?</label></th>
	<td><input type="checkbox" name="asdb_related_status" id="asdb_related_status" value="allow" $asdb_related_status /><br /></td>
</tr>
  </table>\n
END;
}
//сохраняем введенные значения
add_action('personal_options_update', 'asdb_save_preferences');
add_action('edit_user_profile_update', 'asdb_save_preferences');
function asdb_save_preferences($user_id) {
    if (!current_user_can('edit_user', $user_id))
        return FALSE;
    update_usermeta($user_id, 'asdb_metabox_status', $_POST['asdb_metabox_status']);
    update_usermeta($user_id, 'asdb_email_status', $_POST['asdb_email_status']);
    update_usermeta($user_id, 'asdb_related_status', $_POST['asdb_related_status']);
}

// добавляем и удаляем социальные сети
function asdb_social_contactmethod( $contactmethods ) {
  // Удаляем Yahoo YIM
  if ( isset( $contactmethods['yim'] ) )
    unset( $contactmethods['yim'] );
  // Удаляем AIM
  if ( isset( $contactmethods['aim'] ) )
    unset( $contactmethods['aim'] );
  // Удаляем Jabber
  if ( isset( $contactmethods['jabber'] ) )
    unset( $contactmethods['jabber'] );
  // Добавляем VKontakte
  if ( !isset( $contactmethods['vkontakte'] ) )
    $contactmethods['vkontakte'] = 'ВКонтакте';
  // Добавляем Twitter
  if ( !isset( $contactmethods['twitter'] ) )
    $contactmethods['twitter'] = 'Twitter';
  // Добавляем Google Plus
  if ( !isset( $contactmethods['googleplus'] ) )
    $contactmethods['googleplus'] = 'Google Plus';
  // Добавляем Facebook
  if ( !isset( $contactmethods['facebook'] ) )
    $contactmethods['facebook'] = 'Facebook';
  // Добавляем LiveJournal
  if ( !isset( $contactmethods['livejournal'] ) )
    $contactmethods['livejournal'] = 'LiveJournal';
  return $contactmethods;
}
add_filter( 'user_contactmethods', 'asdb_social_contactmethod', 10, 1 );

//формируем бокс Инфо об Авотре с социальными иконками
function asdb_get_author_information() {
    $asdb_metabox_status = get_the_author_meta('asdb_metabox_status', $authordata->ID);
    $asdb_html = '';
if ($asdb_metabox_status == 'allow') {
    $vkontakte = get_the_author_meta( 'vkontakte');
    $twitter = get_the_author_meta( 'twitter');
    $facebook = get_the_author_meta( 'facebook');
    $livejournal = get_the_author_meta( 'livejournal');
    $googleplus = get_the_author_meta( 'googleplus');
	if (isset($vkontakte)) $imageHtml .= '&nbsp;<a class="b-share__handle" href="'.$vkontakte.'" rel="author" target="_blank"><span class="b-share-icon b-share-icon_vkontakte"></span></a>';
	if (isset($twitter)) $imageHtml .= '&nbsp;<a class="b-share__handle" href="'.$twitter.'" rel="author" target="_blank"><span class="b-share-icon b-share-icon_twitter"></span></a>';
     	if (isset($facebook)) $imageHtml .= '&nbsp;<a class="b-share__handle" href="'.$facebook.'" rel="author" target="_blank"><span class="b-share-icon b-share-icon_facebook"></span></a>';
     	if (isset($googleplus)) $imageHtml .= '&nbsp;<a class="b-share__handle" href="'.$googleplus.'" rel="author" target="_blank"><span class="b-share-icon b-share-icon_gplus"></span></a>';
     	if (isset($livejournal)) $imageHtml .= '&nbsp;<a class="b-share__handle" href="'.$livejournal.'" rel="author" target="_blank"><span class="b-share-icon b-share-icon_lj"></span></a>';
	$imageHtml .= '&nbsp;&nbsp;';
    $asdb_post_author = get_the_author_meta('user_email');
    $asdb_html = "<div id='asdb-author-box' class='author-bio'>
                        <div id='author-avatar' class='bio-avatar'>" . get_avatar(get_the_author_email(), '128') . "</div>
                        <div id='author-name' class='bio-name'>" . get_the_author_meta('first_name') . " " . get_the_author_meta('last_name') . "<div id='author-social' class='bio-social'><span class='b-share'>" . $imageHtml . "</span></div></div>
                        <div id='author-desc' class='bio-desc'>" . get_the_author_meta('description') . "</div>
			<div class='clear'></div>
                      </div>";
}
    return $asdb_html;
}

// Формируем бокс с последними постами Автора (4шт)
function asdb_get_author_posts() {
    global $authordata, $post;
    $asdb_related_status = get_the_author_meta('asdb_related_status', $authordata->ID);
    $asdb_html = "";
if ($asdb_related_status == 'allow') {
    $asdb_author_posts = get_posts(array('author' => $authordata->ID,
                'post__not_in' => array($post->ID),
                'posts_per_page' => 4));
    foreach ($asdb_author_posts as $key => $asdb_author_post) {
	$title_post_url = get_permalink($asdb_author_post->ID);
        if (has_post_thumbnail($asdb_author_post->ID)) {
            $asdb_html .= "<li class='asdb-related post-hover'><div class='post-thumbnail'>" . get_the_post_thumbnail($asdb_author_post->ID, array(100, 100)) .
                        "</div><div id='asdb-related-inner'><h4 class='asdb-post-title post-title'><a title='$asdb_author_post->post_title' href='" . $title_post_url . "'>$asdb_author_post->post_title</a></h4></div></li>";
        } else {
            $url = plugins_url();
            $asdb_html .= "<li class='asdb-related post-hover'><div class='post-thumbnail'><img  width='100' height='100' src='" . $url . "/asdb-author-info/img/thumb-medium.png' />
                        </div><div id='asdb-related-inner'><h4 class='asdb-post-title post-title'><a title='$asdb_author_post->post_title' href='" . $title_post_url . "'>$asdb_author_post->post_title</a></h4></div></li>";
        }
    }
    if($asdb_html != ''){
        $asdb_html = "<div id='asdb-post-head'>Последние публикации Автора</div><div id='asdb-post-list'><ul class='asdb-related-post group'>".$asdb_html."</ul></div>";
    }
}
    return $asdb_html;
}

//Вывод бокса отправки почты Автору публикации
function asdb_send_email_box() {
    global $authordata;
    $token = ASDBAuthorInfo::token();
    $asdb_email_status = get_the_author_meta('asdb_email_status', $authordata->ID);
    $asdb_html = '';
    if ($asdb_email_status == 'allow') {
        $asdb_html = '
<div class="asdb-post-head"><a href="javascript:void(0)" onclick="toggleEmail();">Связаться с Автором</a></div>
	<div id="asdbemailpanel" style="display: none;">
<form method="POST" id="asdbForm" class="asdbform" action="javascript:void(null);" >
    <table class="asdb-author-emails">
        <tr>
            <th><label>Имя:</label></th>
            <td><div class="name amess"><input type="text" name="name" id="name" class="text" /></div></td>
        </tr>
        <tr>
            <th><label>EMail:</label></th>
            <td><div class="amess"><input type="text" name="email" id="email" class="text" /></div></td>
        </tr>
        <tr>
            <th><label>Тема:</label></th>
	    <td><div class="amess"><input type="text" name="subject" id="subject" class="text" /></div></td>
        </tr>
        <tr>
            <th><label>Сообщение:</label></th>
	    <td><div class="amess"><textarea name="message" id="message" class="text textarea"></textarea></div></td>
        </tr>
        <tr>
            <th><label></label></th>
            <td><input type="hidden" name="author_id" id="author_id" value="'.$authordata->ID.'" />
		<input type="hidden" name="source" id="source" value="' . ASDB_DIR . '/asdb-data.php" />
		<input type="hidden" name="token" id="token" value="'. $token . '" />
		<input type="hidden" name="submitted" id="submitted" value="send" />
                <input type="submit" name="submit" value="Отправить" id="send" /><!--<div class="loading"></div>-->
            </td>
        </tr>
    </table>
</form></div>
<div class="asdb-author-msg">Ваше сообщение успешно отправлено!</div>
';
    }
    return $asdb_html;
}

// формируем вывод полного метабокса на страницах записей (is_single)
function asdb_generate_author_box($content) {
    if (is_single ()) {
        $asdb_author_info = asdb_get_author_information();
        $asdb_author_posts = asdb_get_author_posts();
        $asdb_email_box = asdb_send_email_box();
        $asdb_html = "<div id='asdb-author-panel'>" . $asdb_author_info . $asdb_author_posts . $asdb_email_box ."</div>";
        return $content . $asdb_html;
    } else {
        return $content;
    }
}

add_filter('the_content', 'asdb_generate_author_box');
add_shortcode('asdb-author-info', 'asdb_generate_author_box');
add_shortcode('asdb-author-info-bio', 'asdb_get_author_info');
add_shortcode('asdb-author-info-related', 'asdb_get_author_posts');
add_shortcode('asdb-author-info-contact', 'asdb_send_email_box');
